import { HTMLElement } from "node-html-parser";
import { ZNoteType } from "./meta";
export interface IElementHandler {
    process(type: string, element: HTMLElement): Promise<string | undefined>;
}
export declare class ZContent {
    #private;
    constructor(contentElement: HTMLElement, type: ZNoteType);
    toHtml(handler?: IElementHandler): Promise<string>;
    get raw(): string;
}
