import { ZLocation } from "./location";
import { IZnelElement } from "./types";
import { HTMLElement } from "node-html-parser";
export declare type ZNoteType = "note/image" | "note/sketch" | "note/checklist" | "note/mixed" | "note/file";
export declare class ZMeta implements IZnelElement {
    #private;
    constructor(metaElement: HTMLElement);
    get title(): string;
    get createdDate(): Date | null;
    get modifiedDate(): Date | null;
    get location(): ZLocation | null;
    get noteColor(): string | null;
    get noteType(): ZNoteType;
    validate(): void;
}
