"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ZMeta_metaElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZMeta = void 0;
const location_1 = require("./location");
const utils_1 = require("./utils");
class ZMeta {
    constructor(metaElement) {
        _ZMeta_metaElement.set(this, void 0);
        __classPrivateFieldSet(this, _ZMeta_metaElement, metaElement, "f");
        this.validate();
    }
    get title() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _ZMeta_metaElement, "f"), "ZTitle");
    }
    get createdDate() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _ZMeta_metaElement, "f"), "ZCreatedDate");
    }
    get modifiedDate() {
        return (0, utils_1.getAsDate)(__classPrivateFieldGet(this, _ZMeta_metaElement, "f"), "ZModifiedDate");
    }
    get location() {
        const locationElement = __classPrivateFieldGet(this, _ZMeta_metaElement, "f").querySelector("zlocation");
        if (!locationElement)
            return null;
        return new location_1.ZLocation(locationElement);
    }
    get noteColor() {
        return (0, utils_1.getAsString)(__classPrivateFieldGet(this, _ZMeta_metaElement, "f"), "ZNoteColor");
    }
    get noteType() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _ZMeta_metaElement, "f"), "ZNoteType");
    }
    validate() {
        this.title && this.noteType;
    }
}
exports.ZMeta = ZMeta;
_ZMeta_metaElement = new WeakMap();
