"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ZLocation_locationElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZLocation = void 0;
const utils_1 = require("./utils");
class ZLocation {
    constructor(locationElement) {
        _ZLocation_locationElement.set(this, void 0);
        __classPrivateFieldSet(this, _ZLocation_locationElement, locationElement, "f");
    }
    get longitude() {
        return (0, utils_1.getAsNumberRequired)(__classPrivateFieldGet(this, _ZLocation_locationElement, "f"), "ZLongitude");
    }
    get latitude() {
        return (0, utils_1.getAsNumberRequired)(__classPrivateFieldGet(this, _ZLocation_locationElement, "f"), "ZLatitude");
    }
    get city() {
        return (0, utils_1.getAsStringRequired)(__classPrivateFieldGet(this, _ZLocation_locationElement, "f"), "ZCity");
    }
    validate() {
        this.longitude && this.latitude && this.city;
    }
}
exports.ZLocation = ZLocation;
_ZLocation_locationElement = new WeakMap();
